<?php
namespace App;

use OutOfBoundsException;

class Config
{
    private array $config;

    public function __construct()
    {
        $this->config = parse_ini_file(__DIR__ . '/../config.ini');
    }

    /**
     * @param string $key
     * @return mixed
     */
    public function get(string $key)
    {
        if (!array_key_exists($key, $this->config)) {
            throw new OutOfBoundsException('Отсутствует параметр' . $key . ' в config.ini');
        }

        return $this->config[$key];
    }
}