<?php


namespace App;


use Carbon\Carbon;

class Logger
{
    public function __construct()
    {
        $this->deleteOldLogs();
    }

    private function getLogPath($subDays = 0): string
    {
        return __DIR__ . '/../logs/' . Carbon::today()->subDays($subDays)->format('Y_m_d') . '_logs.txt';
    }

    public function writeLog(string $message): void
    {
        file_put_contents($this->getLogPath(), date('H:i:s') . ' - ' . $message . PHP_EOL, FILE_APPEND);
    }

    private function deleteOldLogs(): void
    {
        for ($i = 7; $i < 14; $i++) {
            $path = $this->getLogPath($i);
            if (file_exists($path)) {
                unlink($path);
            }
        }
    }
}