<?php

use App\Logger;
use App\Request;

require_once __DIR__ . '/vendor/autoload.php';
require_once __DIR__ . '/classes/Request.php';
require_once __DIR__ . '/classes/Config.php';
require_once __DIR__ . '/classes/Logger.php';

set_time_limit(0);
date_default_timezone_set('Europe/Moscow');
ini_set("log_errors", 1);
ini_set("error_log", __DIR__ . '/logs/' . date('Y_m_d') . '_php-error.log');

$start = time();

$logger = new Logger();

$request = new Request($logger, exec('hostname'));

while ((time() - $start) < 295) {
    $tasks = $request->getLabelTask();

    if (count($tasks) === 0) {
        sleep(5);
        continue;
    }

    foreach ($tasks as $task) {
        $labelPath = __DIR__ . '/labels/' . $task['file_name'];

        if (!file_put_contents($labelPath, base64_decode($task['label']))) {
            $request->sendMessage('Ошибка записи этикетки на диск ' . json_encode($task));
            continue;
        }

        $command = 'print /D:' . $task['local_name'] . ' ' . str_replace('/', '\\', $labelPath);

        $try = 1;

        do {
            $print_result = mb_convert_encoding(exec($command), 'utf-8', 'cp866');

            if (strpos($print_result, 'is currently being printed') !== false) {
                $logger->writeLog('печатается задание #' . $task['id']);
                break;
            }

            $request->sendMessage(
                'ошибка печати задания #' . $task['id'] . ', попытка ' . $try . ': ' . $print_result,
                $task['id']
            );
            $try++;
            sleep(5);
        } while ($try < 4);

        @unlink($labelPath);
        usleep(50000);
    }

    sleep(1);
}